=== debian/changelog ===
vc (0.7.4-0ubuntu1) utopic; urgency=medium

  * New upstream release
  * Add kubuntu_disable-broken-tests.diff queried upstream

 -- Jonathan Riddell <jriddell@ubuntu.com>  Mon, 11 Aug 2014 13:59:59 +0200
