=== debian/changelog ===
vc (1.3.0-0ubuntu1) zesty; urgency=medium

  [ Simon Quigley ]
  * New upstream release (LP: #1629881).
  * Update debian/copyright with new license.
  * Bump Standards-version to 3.9.8.
  * Update debhelper version to 10.
  * Change homepage to the correct one.
  * Remove outdated patches, not needed anymore.
  * Clean up comments in debian/rules.
  * Update debian/watch file to the new upstream location, using the
    workaround for GitHub specified in the Debian wiki.
  * Run wrap-and-sort.
  * Change maintainer to "Ubuntu Developers".

  [ Mattia Rizzolo ]
  * Further update debian/copyright.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 11 Feb 2017 18:54:07 -0600
