=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/Vc-$1\.tar\.gz/ \
  https://github.com/VcDevel/Vc/releases .*/v?(\d\S+)\.tar\.gz
